//+------------------------------------------------------------------+
//|                                                     AtrLabel.mq4 |
//|                                                      nicholishen |
//|                         https://www.forexfactory.com/nicholishen |
//+------------------------------------------------------------------+
#property copyright "nicholishen"
#property link      "https://www.forexfactory.com/nicholishen"
#property version   "1.00"
#property strict
#property indicator_chart_window
//--- input parameters
input int                  inp_atr_period = 20;//ATR period
extern ENUM_TIMEFRAMES     inp_timeframe = PERIOD_CURRENT;//Timeframe
input ENUM_BASE_CORNER     inp_corner = CORNER_LEFT_LOWER;//Corner to display
input color                inp_color = clrDarkOrange;//Color
input int                  inp_fontsize = 18;//Font-size

#include <Indicators\Indicators.mqh>
#include <ChartObjects\ChartObjectsTxtControls.mqh>

CiATR g_atr;
CChartObjectLabel g_label;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
   if(inp_timeframe == PERIOD_CURRENT)
      inp_timeframe = (ENUM_TIMEFRAMES)_Period;
   if(!g_atr.Create(_Symbol, inp_timeframe, inp_atr_period)
      || !g_label.Create(0, "__atr_label__", 0, 0, 0)
      || !g_label.Corner(CORNER_LEFT_LOWER)
      || !g_label.Description("Calculating ATR")
      || !g_label.Anchor(ANCHOR_LEFT_LOWER)
      || !g_label.Color(inp_color)
      || !g_label.FontSize(inp_fontsize)
      || !g_label.Font("Consolas")
      || !set_corner(g_label, inp_corner)
   )
      return INIT_FAILED;
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   g_label.Description(StringFormat(
      "[%s] ATR(%d) = %d",
      StringSubstr(EnumToString(inp_timeframe), 7),
      g_atr.MaPeriod(),
      int(round(g_atr.Main(0) / _Point))
   ));
   return(rates_total);
}
//+------------------------------------------------------------------+

bool set_corner(CChartObjectLabel &_label, ENUM_BASE_CORNER corner)
{
   if(!_label.Corner(corner))
      return false;
   switch(corner){
      case CORNER_LEFT_LOWER:
         return _label.Anchor(ANCHOR_LEFT_LOWER);
      case CORNER_LEFT_UPPER:
         return _label.Anchor(ANCHOR_LEFT_UPPER);
      case CORNER_RIGHT_UPPER:
         return _label.Anchor(ANCHOR_RIGHT_UPPER);
      default:
         return _label.Anchor(ANCHOR_RIGHT_LOWER);
   }
}